/*
    $Id: netusergroup.h,v 1.1.1.1 2005/07/07 15:05:59 oflebbe Exp $

    Copyright (C) 2003 Olaf Flebbe, Science and Computing AG
                       o.flebbe@science-computing.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/
#ifndef NETUSERGROUP_H
#define NETUSERGROUP_H
#define WINDOWS_MEAN_AND_LEAN
#define UNICODE

#include <stdio.h>
#include "typedefs.h"

int
addUserToGroup( const mystring& userName, const mystring& groupName);

int 
delUserFromGroup( const mystring& userName, const mystring& groupName);

int
addUser( const mystring& userName);
int 
addUser( const mystring& userName, const mystring& password, const mystring& homepath, const mystring& homedrive, 
			const mystring& profile, const mystring& script);

int 
modifyUser( const mystring& userName, const mystring& password, const mystring& homepath, const mystring& homedrive, 
			const mystring& profile, const mystring& script);

int
addGroup( const mystring& userName);

int
delUser( const mystring& userName);

int
isDisabledUser( const mystring& userName);

int
resetAccountExpiry( const mystring& userName, const mystring& password, FILE *fp);

stringSet 
listUsers();

stringSet 
listGroups( const mystring& user);
#endif
